Bug 1913439 - python-jsonpickle fails to build with new numpy version: ValueError: entry not a 2- or 3- tuple
Summary: python-jsonpickle fails to build with new numpy version: ValueError: entry no...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: python-jsonpickle
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Gwyn Ciesla
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: F34FTBFS PYTHON3.10 1917068
TreeView+ depends on / blocked
 
Reported: 2021-01-06 18:49 UTC by Miro Hrončok
Modified: 2021-06-07 15:40 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-06-07 15:40:19 UTC
Type: Bug


Attachments (Terms of Use)

Description Miro Hrončok 2021-01-06 18:49:54 UTC
python-jsonpickle fails to build with Python 3.10.0a4 and Python 3.9.1. This seems related to the updated NumPy.

______________________ NumpyTestCase.test_dtype_roundtrip ______________________

self = <numpy_test.NumpyTestCase testMethod=test_dtype_roundtrip>

    def test_dtype_roundtrip(self):
        if self.should_skip:
            return self.skip('numpy is not importable')
        dtypes = [
            np.int,
            np.float,
            np.complex,
            np.int32,
            np.str,
            np.object,
            np.unicode,
            np.dtype('f4,i4,f2,i1'),
            np.dtype(('f4', 'i4'), ('f2', 'i1')),
            np.dtype('1i4', align=True),
            np.dtype('M8[7D]'),
            np.dtype(
                {
                    'names': ['f0', 'f1', 'f2'],
                    'formats': ['<u4', '<u2', '<u2'],
                    'offsets': [0, 0, 2],
                },
                align=True,
            ),
        ]
    
        if not PY2:
            dtypes.extend(
                [
                    np.dtype([('f0', 'i4'), ('f2', 'i1')]),
                    np.dtype(
                        [
                            (
                                'top',
                                [
                                    ('tiles', ('>f4', (64, 64)), (1,)),
                                    ('rtile', '>f4', (64, 36)),
                                ],
                                (3,),
                            ),
                            (
                                'bottom',
                                [
                                    ('bleft', ('>f4', (8, 64)), (1,)),
                                    ('bright', '>f4', (8, 36)),
                                ],
                            ),
                        ]
                    ),
                ]
            )
    
        for dtype in dtypes:
>           self.assertEqual(self.roundtrip(dtype), dtype)

tests/numpy_test.py:95: 
_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ 
/usr/lib64/python3.10/site-packages/numpy/core/_internal.py:61: in _usefields
    names, formats, offsets, titles = _makenames_list(adict, align)
_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ 

adict = {'dtype': "[('f0', '<f4'), ('f1', '<i4'), ('f2', '<f2'), ('f3', 'i1')]", 'py/object': 'numpy.dtype[void]'}
align = 0

    def _makenames_list(adict, align):
        allfields = []
    
        for fname, obj in adict.items():
            n = len(obj)
            if not isinstance(obj, tuple) or n not in (2, 3):
>               raise ValueError("entry not a 2- or 3- tuple")
E               ValueError: entry not a 2- or 3- tuple

/usr/lib64/python3.10/site-packages/numpy/core/_internal.py:31: ValueError

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01865152-python-jsonpickle/

For all our attempts to build python-jsonpickle with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-jsonpickle/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Gwyn Ciesla 2021-01-06 19:01:59 UTC
https://github.com/jsonpickle/jsonpickle/issues/336

Adding to BZ fails with RPC error.

Comment 2 Ben Cotton 2021-02-09 15:37:39 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.

Comment 3 Miro Hrončok 2021-06-04 20:14:44 UTC
This is a mass-posted update. Sorry if it is not 100% accurate to this bugzilla.


The Python 3.10 rebuild is in progress in a Koji side tag. If you manage to fix the problem, please commit the fix in the rawhide branch, but don't build the package in regular rawhide.

You can either build the package in the side tag, with:

    $ fedpkg build --target=f35-python

Or you can the build and we will eventually build it for you.

Note that the rebuild is still in progress, so not all (build) dependencies of this package might be available right away.

Thanks.

See also https://fedoraproject.org/wiki/Changes/Python3.10

If you have general questions about the rebuild, please use this mailing list thread: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/G47SGOYIQLRDTWGOSLSWERZSSHXDEDH5/


Note You need to log in before you can comment on or make changes to this bug.